import java.util.*;

public class Gen {

	public static void main(String[] args) {

		if (args.length != 3) {
			System.out.println("Usage: java Gen num mode length");
			return;
		}

		int num = Integer.parseInt(args[0]);
		int mode = Integer.parseInt(args[1]);
		int length = Integer.parseInt(args[2]);
		int width = Common.width(mode);
		int height = Common.height(mode);
		HashSet<String> excludedPoints = Common.excludedPoints(mode);
		Random rand = new Random();

		if (Common.endPoint(mode) != null) length -= 1;
		for (int i = 0; i < num; i++) {
			int count = 0;
			int prevx = -1;
			int prevy = -1;
			if (Common.startPoint(mode) != null) {
				System.out.print(Common.startPoint(mode) + ",");
				prevx = Common.startPointX(mode);
				prevy = Common.startPointY(mode);
				count++;
			}
			while (count < length) {
				int x = rand.nextInt(width);
				int y = rand.nextInt(height);
				if (((x != prevx) || (y != prevy)) && !excludedPoints.contains(x + "x" + y)) {
					System.out.print(x);
					System.out.print("x");
					System.out.print(y);
					System.out.print(",");
					prevx = x;
					prevy = y;
					count++;
				}
			}
			if (Common.endPoint(mode) != null) {
				System.out.print(Common.endPoint(mode) + ",");
				prevx = Common.endPointX(mode);
				prevy = Common.endPointY(mode);
				count++;
			}
			System.out.println();
		}
	}

}
